-------------------------------------------------------------------------------
--
-- quantmux.vhd
--
-- Modified 4/27/2007
-- Ian Roth
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use IEEE.std_logic_arith.all;        


entity quantmux is

  port (
	input : in signed(31 downto 0);
	dequant : in signed(31 downto 0);
	output : out signed(31 downto 0)
  );

end quantmux;

architecture behavior of quantmux is

  signal temp : signed(31 downto 0);
  signal multi : signed (63 downto 0);

begin

  multi <= (input * dequant);
  temp <= multi(31 downto 0);

  with dequant select
	output <= input when "00000000000000000000000000000001",
		      temp when others;
		
end behavior;